package com.sun.jmx.snmp.IPAcl;

import java.io.IOException;

class ParserTokenManager implements ParserConstants
{
    static final long[] jjbitVec0;
    static final int[] jjnextStates;
    public static final String[] jjstrLiteralImages;
    public static final String[] lexStateNames;
    static final long[] jjtoToken;
    static final long[] jjtoSkip;
    private ASCII_CharStream input_stream;
    private final int[] jjrounds;
    private final int[] jjstateSet;
    protected char curChar;
    int curLexState;
    int defaultLexState;
    int jjnewStateCnt;
    int jjround;
    int jjmatchedPos;
    int jjmatchedKind;
    
    private final int jjStopStringLiteralDfa_0(int n, long n2) {
        switch (n) {
            case 0: {
                if ((n2 & 0x8000L) != 0x0L) {
                    return 0;
                }
                if ((n2 & 0xFE5000L) != 0x0L) {
                    this.jjmatchedKind = 31;
                    return 47;
                }
                if ((n2 & 0xD80L) != 0x0L) {
                    this.jjmatchedKind = 31;
                    return 48;
                }
                return -1;
            }
            case 1: {
                if ((n2 & 0xFE5C00L) != 0x0L) {
                    this.jjmatchedKind = 31;
                    this.jjmatchedPos = 1;
                    return 49;
                }
                if ((n2 & 0x180L) != 0x0L) {
                    this.jjmatchedKind = 31;
                    this.jjmatchedPos = 1;
                    return 50;
                }
                return -1;
            }
            case 2: {
                if ((n2 & 0xFE5C00L) != 0x0L) {
                    this.jjmatchedKind = 31;
                    this.jjmatchedPos = 2;
                    return 49;
                }
                if ((n2 & 0x100L) != 0x0L) {
                    return 49;
                }
                if ((n2 & 0x80L) != 0x0L) {
                    this.jjmatchedKind = 31;
                    this.jjmatchedPos = 2;
                    return 50;
                }
                return -1;
            }
            case 3: {
                if ((n2 & 0x565C00L) != 0x0L) {
                    if (this.jjmatchedPos != 3) {
                        this.jjmatchedKind = 31;
                        this.jjmatchedPos = 3;
                    }
                    return 49;
                }
                else {
                    if ((n2 & 0xA80000L) != 0x0L) {
                        return 49;
                    }
                    if ((n2 & 0x80L) != 0x0L) {
                        if (this.jjmatchedPos != 3) {
                            this.jjmatchedKind = 31;
                            this.jjmatchedPos = 3;
                        }
                        return 50;
                    }
                    else {
                        return -1;
                    }
                }
            }
            case 4: {
                if ((n2 & 0xA00000L) != 0x0L) {
                    return 51;
                }
                if ((n2 & 0x60000L) != 0x0L) {
                    if (this.jjmatchedPos < 3) {
                        this.jjmatchedKind = 31;
                        this.jjmatchedPos = 3;
                    }
                    return 51;
                }
                else {
                    if ((n2 & 0x1000L) != 0x0L) {
                        return 49;
                    }
                    if ((n2 & 0x504C80L) != 0x0L) {
                        this.jjmatchedKind = 31;
                        this.jjmatchedPos = 4;
                        return 49;
                    }
                    return -1;
                }
            }
            case 5: {
                if ((n2 & 0x500080L) != 0x0L) {
                    return 49;
                }
                if ((n2 & 0x4C00L) != 0x0L) {
                    if (this.jjmatchedPos != 5) {
                        this.jjmatchedKind = 31;
                        this.jjmatchedPos = 5;
                    }
                    return 49;
                }
                else if ((n2 & 0xA60000L) != 0x0L) {
                    if (this.jjmatchedPos != 5) {
                        this.jjmatchedKind = 31;
                        this.jjmatchedPos = 5;
                    }
                    return 51;
                }
                else {
                    return -1;
                }
            }
            case 6: {
                if ((n2 & 0x400000L) != 0x0L) {
                    return 51;
                }
                if ((n2 & 0x4C00L) != 0x0L) {
                    this.jjmatchedKind = 31;
                    this.jjmatchedPos = 6;
                    return 49;
                }
                if ((n2 & 0xA60000L) != 0x0L) {
                    this.jjmatchedKind = 31;
                    this.jjmatchedPos = 6;
                    return 51;
                }
                return -1;
            }
            case 7: {
                if ((n2 & 0x660000L) != 0x0L) {
                    this.jjmatchedKind = 31;
                    this.jjmatchedPos = 7;
                    return 51;
                }
                if ((n2 & 0x800000L) != 0x0L) {
                    return 51;
                }
                if ((n2 & 0x4000L) != 0x0L) {
                    return 49;
                }
                if ((n2 & 0xC00L) != 0x0L) {
                    this.jjmatchedKind = 31;
                    this.jjmatchedPos = 7;
                    return 49;
                }
                return -1;
            }
            case 8: {
                if ((n2 & 0x20000L) != 0x0L) {
                    return 51;
                }
                if ((n2 & 0xC00L) != 0x0L) {
                    this.jjmatchedKind = 31;
                    this.jjmatchedPos = 8;
                    return 49;
                }
                if ((n2 & 0x640000L) != 0x0L) {
                    this.jjmatchedKind = 31;
                    this.jjmatchedPos = 8;
                    return 51;
                }
                return -1;
            }
            case 9: {
                if ((n2 & 0x40000L) != 0x0L) {
                    return 51;
                }
                if ((n2 & 0x800L) != 0x0L) {
                    return 49;
                }
                if ((n2 & 0x600000L) != 0x0L) {
                    this.jjmatchedKind = 31;
                    this.jjmatchedPos = 9;
                    return 51;
                }
                if ((n2 & 0x400L) != 0x0L) {
                    this.jjmatchedKind = 31;
                    this.jjmatchedPos = 9;
                    return 49;
                }
                return -1;
            }
            case 10: {
                if ((n2 & 0x600000L) != 0x0L) {
                    this.jjmatchedKind = 31;
                    this.jjmatchedPos = 10;
                    return 51;
                }
                if ((n2 & 0x400L) != 0x0L) {
                    return 49;
                }
                return -1;
            }
            case 11: {
                if ((n2 & 0x600000L) != 0x0L) {
                    this.jjmatchedKind = 31;
                    this.jjmatchedPos = 11;
                    return 51;
                }
                return -1;
            }
            case 12: {
                if ((n2 & 0x600000L) != 0x0L) {
                    this.jjmatchedKind = 31;
                    this.jjmatchedPos = 12;
                    return 51;
                }
                return -1;
            }
            case 13: {
                if ((n2 & 0x400000L) != 0x0L) {
                    this.jjmatchedKind = 31;
                    this.jjmatchedPos = 13;
                    return 51;
                }
                if ((n2 & 0x200000L) != 0x0L) {
                    return 51;
                }
                return -1;
            }
            case 14: {
                if ((n2 & 0x400000L) != 0x0L) {
                    this.jjmatchedKind = 31;
                    this.jjmatchedPos = 14;
                    return 51;
                }
                return -1;
            }
            default: {
                return -1;
            }
        }
    }
    
    private final int jjStartNfa_0(int n, long n2) {
        return this.jjMoveNfa_0(this.jjStopStringLiteralDfa_0(n, n2), n + 1);
    }
    
    private final int jjStopAtPos(int jjmatchedPos, int jjmatchedKind) {
        this.jjmatchedKind = jjmatchedKind;
        return (this.jjmatchedPos = jjmatchedPos) + 1;
    }
    
    private final int jjStartNfaWithStates_0(int jjmatchedPos, int jjmatchedKind, int n) {
        this.jjmatchedKind = jjmatchedKind;
        this.jjmatchedPos = jjmatchedPos;
        try {
            this.curChar = this.input_stream.readChar();
        }
        catch (IOException ex) {
            return jjmatchedPos + 1;
        }
        return this.jjMoveNfa_0(n, jjmatchedPos + 1);
    }
    
    private final int jjMoveStringLiteralDfa0_0() {
        switch (this.curChar) {
            case '!': {
                return this.jjStopAtPos(0, 38);
            }
            case ',': {
                return this.jjStopAtPos(0, 36);
            }
            case '-': {
                return this.jjStartNfaWithStates_0(0, 15, 0);
            }
            case '.': {
                return this.jjStopAtPos(0, 37);
            }
            case '/': {
                return this.jjStopAtPos(0, 39);
            }
            case '=': {
                return this.jjStopAtPos(0, 9);
            }
            case 'a': {
                return this.jjMoveStringLiteralDfa1_0(384L);
            }
            case 'c': {
                return this.jjMoveStringLiteralDfa1_0(1024L);
            }
            case 'e': {
                return this.jjMoveStringLiteralDfa1_0(2048L);
            }
            case 'h': {
                return this.jjMoveStringLiteralDfa1_0(4096L);
            }
            case 'i': {
                return this.jjMoveStringLiteralDfa1_0(5242880L);
            }
            case 'm': {
                return this.jjMoveStringLiteralDfa1_0(16384L);
            }
            case 'r': {
                return this.jjMoveStringLiteralDfa1_0(393216L);
            }
            case 't': {
                return this.jjMoveStringLiteralDfa1_0(11010048L);
            }
            case '{': {
                return this.jjStopAtPos(0, 13);
            }
            case '}': {
                return this.jjStopAtPos(0, 16);
            }
            default: {
                return this.jjMoveNfa_0(5, 0);
            }
        }
    }
    
    private final int jjMoveStringLiteralDfa1_0(long n) {
        try {
            this.curChar = this.input_stream.readChar();
        }
        catch (IOException ex) {
            this.jjStopStringLiteralDfa_0(0, n);
            return 1;
        }
        switch (this.curChar) {
            case 'a': {
                return this.jjMoveStringLiteralDfa2_0(n, 16384L);
            }
            case 'c': {
                return this.jjMoveStringLiteralDfa2_0(n, 384L);
            }
            case 'e': {
                return this.jjMoveStringLiteralDfa2_0(n, 393216L);
            }
            case 'n': {
                return this.jjMoveStringLiteralDfa2_0(n, 5244928L);
            }
            case 'o': {
                return this.jjMoveStringLiteralDfa2_0(n, 5120L);
            }
            case 'r': {
                return this.jjMoveStringLiteralDfa2_0(n, 11010048L);
            }
            default: {
                return this.jjStartNfa_0(0, n);
            }
        }
    }
    
    private final int jjMoveStringLiteralDfa2_0(long n, long n2) {
        if ((n2 &= n) == 0x0L) {
            return this.jjStartNfa_0(0, n);
        }
        try {
            this.curChar = this.input_stream.readChar();
        }
        catch (IOException ex) {
            this.jjStopStringLiteralDfa_0(1, n2);
            return 2;
        }
        switch (this.curChar) {
            case 'a': {
                return this.jjMoveStringLiteralDfa3_0(n2, 11403264L);
            }
            case 'c': {
                return this.jjMoveStringLiteralDfa3_0(n2, 128L);
            }
            case 'f': {
                return this.jjMoveStringLiteralDfa3_0(n2, 5242880L);
            }
            case 'l': {
                if ((n2 & 0x100L) != 0x0L) {
                    return this.jjStartNfaWithStates_0(2, 8, 49);
                }
                break;
            }
            case 'm': {
                return this.jjMoveStringLiteralDfa3_0(n2, 1024L);
            }
            case 'n': {
                return this.jjMoveStringLiteralDfa3_0(n2, 16384L);
            }
            case 's': {
                return this.jjMoveStringLiteralDfa3_0(n2, 4096L);
            }
            case 't': {
                return this.jjMoveStringLiteralDfa3_0(n2, 2048L);
            }
        }
        return this.jjStartNfa_0(1, n2);
    }
    
    private final int jjMoveStringLiteralDfa3_0(long n, long n2) {
        if ((n2 &= n) == 0x0L) {
            return this.jjStartNfa_0(1, n);
        }
        try {
            this.curChar = this.input_stream.readChar();
        }
        catch (IOException ex) {
            this.jjStopStringLiteralDfa_0(2, n2);
            return 3;
        }
        switch (this.curChar) {
            case 'a': {
                return this.jjMoveStringLiteralDfa4_0(n2, 16384L);
            }
            case 'd': {
                return this.jjMoveStringLiteralDfa4_0(n2, 393216L);
            }
            case 'e': {
                return this.jjMoveStringLiteralDfa4_0(n2, 2176L);
            }
            case 'm': {
                return this.jjMoveStringLiteralDfa4_0(n2, 1024L);
            }
            case 'o': {
                return this.jjMoveStringLiteralDfa4_0(n2, 5242880L);
            }
            case 'p': {
                if ((n2 & 0x80000L) != 0x0L) {
                    this.jjmatchedKind = 19;
                    this.jjmatchedPos = 3;
                }
                return this.jjMoveStringLiteralDfa4_0(n2, 10485760L);
            }
            case 't': {
                return this.jjMoveStringLiteralDfa4_0(n2, 4096L);
            }
            default: {
                return this.jjStartNfa_0(2, n2);
            }
        }
    }
    
    private final int jjMoveStringLiteralDfa4_0(long n, long n2) {
        if ((n2 &= n) == 0x0L) {
            return this.jjStartNfa_0(2, n);
        }
        try {
            this.curChar = this.input_stream.readChar();
        }
        catch (IOException ex) {
            this.jjStopStringLiteralDfa_0(3, n2);
            return 4;
        }
        switch (this.curChar) {
            case '-': {
                return this.jjMoveStringLiteralDfa5_0(n2, 10878976L);
            }
            case 'g': {
                return this.jjMoveStringLiteralDfa5_0(n2, 16384L);
            }
            case 'r': {
                return this.jjMoveStringLiteralDfa5_0(n2, 5244928L);
            }
            case 's': {
                if ((n2 & 0x1000L) != 0x0L) {
                    return this.jjStartNfaWithStates_0(4, 12, 49);
                }
                return this.jjMoveStringLiteralDfa5_0(n2, 128L);
            }
            case 'u': {
                return this.jjMoveStringLiteralDfa5_0(n2, 1024L);
            }
            default: {
                return this.jjStartNfa_0(3, n2);
            }
        }
    }
    
    private final int jjMoveStringLiteralDfa5_0(long n, long n2) {
        if ((n2 &= n) == 0x0L) {
            return this.jjStartNfa_0(3, n);
        }
        try {
            this.curChar = this.input_stream.readChar();
        }
        catch (IOException ex) {
            this.jjStopStringLiteralDfa_0(4, n2);
            return 5;
        }
        switch (this.curChar) {
            case 'c': {
                return this.jjMoveStringLiteralDfa6_0(n2, 2097152L);
            }
            case 'e': {
                return this.jjMoveStringLiteralDfa6_0(n2, 16384L);
            }
            case 'm': {
                if ((n2 & 0x100000L) != 0x0L) {
                    this.jjmatchedKind = 20;
                    this.jjmatchedPos = 5;
                }
                return this.jjMoveStringLiteralDfa6_0(n2, 4194304L);
            }
            case 'n': {
                return this.jjMoveStringLiteralDfa6_0(n2, 8389632L);
            }
            case 'o': {
                return this.jjMoveStringLiteralDfa6_0(n2, 131072L);
            }
            case 'p': {
                return this.jjMoveStringLiteralDfa6_0(n2, 2048L);
            }
            case 's': {
                if ((n2 & 0x80L) != 0x0L) {
                    return this.jjStartNfaWithStates_0(5, 7, 49);
                }
                break;
            }
            case 'w': {
                return this.jjMoveStringLiteralDfa6_0(n2, 262144L);
            }
        }
        return this.jjStartNfa_0(4, n2);
    }
    
    private final int jjMoveStringLiteralDfa6_0(long n, long n2) {
        if ((n2 &= n) == 0x0L) {
            return this.jjStartNfa_0(4, n);
        }
        try {
            this.curChar = this.input_stream.readChar();
        }
        catch (IOException ex) {
            this.jjStopStringLiteralDfa_0(5, n2);
            return 6;
        }
        switch (this.curChar) {
            case '-': {
                return this.jjMoveStringLiteralDfa7_0(n2, 4194304L);
            }
            case 'i': {
                return this.jjMoveStringLiteralDfa7_0(n2, 1024L);
            }
            case 'n': {
                return this.jjMoveStringLiteralDfa7_0(n2, 131072L);
            }
            case 'o': {
                return this.jjMoveStringLiteralDfa7_0(n2, 2097152L);
            }
            case 'r': {
                return this.jjMoveStringLiteralDfa7_0(n2, 280576L);
            }
            case 'u': {
                return this.jjMoveStringLiteralDfa7_0(n2, 8388608L);
            }
            default: {
                return this.jjStartNfa_0(5, n2);
            }
        }
    }
    
    private final int jjMoveStringLiteralDfa7_0(long n, long n2) {
        if ((n2 &= n) == 0x0L) {
            return this.jjStartNfa_0(5, n);
        }
        try {
            this.curChar = this.input_stream.readChar();
        }
        catch (IOException ex) {
            this.jjStopStringLiteralDfa_0(6, n2);
            return 7;
        }
        switch (this.curChar) {
            case 'c': {
                return this.jjMoveStringLiteralDfa8_0(n2, 4194304L);
            }
            case 'i': {
                return this.jjMoveStringLiteralDfa8_0(n2, 264192L);
            }
            case 'l': {
                return this.jjMoveStringLiteralDfa8_0(n2, 131072L);
            }
            case 'm': {
                if ((n2 & 0x800000L) != 0x0L) {
                    return this.jjStartNfaWithStates_0(7, 23, 51);
                }
                return this.jjMoveStringLiteralDfa8_0(n2, 2097152L);
            }
            case 's': {
                if ((n2 & 0x4000L) != 0x0L) {
                    return this.jjStartNfaWithStates_0(7, 14, 49);
                }
                break;
            }
            case 't': {
                return this.jjMoveStringLiteralDfa8_0(n2, 1024L);
            }
        }
        return this.jjStartNfa_0(6, n2);
    }
    
    private final int jjMoveStringLiteralDfa8_0(long n, long n2) {
        if ((n2 &= n) == 0x0L) {
            return this.jjStartNfa_0(6, n);
        }
        try {
            this.curChar = this.input_stream.readChar();
        }
        catch (IOException ex) {
            this.jjStopStringLiteralDfa_0(7, n2);
            return 8;
        }
        switch (this.curChar) {
            case 'i': {
                return this.jjMoveStringLiteralDfa9_0(n2, 1024L);
            }
            case 'm': {
                return this.jjMoveStringLiteralDfa9_0(n2, 2097152L);
            }
            case 'o': {
                return this.jjMoveStringLiteralDfa9_0(n2, 4194304L);
            }
            case 's': {
                return this.jjMoveStringLiteralDfa9_0(n2, 2048L);
            }
            case 't': {
                return this.jjMoveStringLiteralDfa9_0(n2, 262144L);
            }
            case 'y': {
                if ((n2 & 0x20000L) != 0x0L) {
                    return this.jjStartNfaWithStates_0(8, 17, 51);
                }
                break;
            }
        }
        return this.jjStartNfa_0(7, n2);
    }
    
    private final int jjMoveStringLiteralDfa9_0(long n, long n2) {
        if ((n2 &= n) == 0x0L) {
            return this.jjStartNfa_0(7, n);
        }
        try {
            this.curChar = this.input_stream.readChar();
        }
        catch (IOException ex) {
            this.jjStopStringLiteralDfa_0(8, n2);
            return 9;
        }
        switch (this.curChar) {
            case 'e': {
                if ((n2 & 0x800L) != 0x0L) {
                    return this.jjStartNfaWithStates_0(9, 11, 49);
                }
                if ((n2 & 0x40000L) != 0x0L) {
                    return this.jjStartNfaWithStates_0(9, 18, 51);
                }
                return this.jjMoveStringLiteralDfa10_0(n2, 1024L);
            }
            case 'm': {
                return this.jjMoveStringLiteralDfa10_0(n2, 4194304L);
            }
            case 'u': {
                return this.jjMoveStringLiteralDfa10_0(n2, 2097152L);
            }
            default: {
                return this.jjStartNfa_0(8, n2);
            }
        }
    }
    
    private final int jjMoveStringLiteralDfa10_0(long n, long n2) {
        if ((n2 &= n) == 0x0L) {
            return this.jjStartNfa_0(8, n);
        }
        try {
            this.curChar = this.input_stream.readChar();
        }
        catch (IOException ex) {
            this.jjStopStringLiteralDfa_0(9, n2);
            return 10;
        }
        switch (this.curChar) {
            case 'm': {
                return this.jjMoveStringLiteralDfa11_0(n2, 4194304L);
            }
            case 'n': {
                return this.jjMoveStringLiteralDfa11_0(n2, 2097152L);
            }
            case 's': {
                if ((n2 & 0x400L) != 0x0L) {
                    return this.jjStartNfaWithStates_0(10, 10, 49);
                }
                break;
            }
        }
        return this.jjStartNfa_0(9, n2);
    }
    
    private final int jjMoveStringLiteralDfa11_0(long n, long n2) {
        if ((n2 &= n) == 0x0L) {
            return this.jjStartNfa_0(9, n);
        }
        try {
            this.curChar = this.input_stream.readChar();
        }
        catch (IOException ex) {
            this.jjStopStringLiteralDfa_0(10, n2);
            return 11;
        }
        switch (this.curChar) {
            case 'i': {
                return this.jjMoveStringLiteralDfa12_0(n2, 2097152L);
            }
            case 'u': {
                return this.jjMoveStringLiteralDfa12_0(n2, 4194304L);
            }
            default: {
                return this.jjStartNfa_0(10, n2);
            }
        }
    }
    
    private final int jjMoveStringLiteralDfa12_0(long n, long n2) {
        if ((n2 &= n) == 0x0L) {
            return this.jjStartNfa_0(10, n);
        }
        try {
            this.curChar = this.input_stream.readChar();
        }
        catch (IOException ex) {
            this.jjStopStringLiteralDfa_0(11, n2);
            return 12;
        }
        switch (this.curChar) {
            case 'n': {
                return this.jjMoveStringLiteralDfa13_0(n2, 4194304L);
            }
            case 't': {
                return this.jjMoveStringLiteralDfa13_0(n2, 2097152L);
            }
            default: {
                return this.jjStartNfa_0(11, n2);
            }
        }
    }
    
    private final int jjMoveStringLiteralDfa13_0(long n, long n2) {
        if ((n2 &= n) == 0x0L) {
            return this.jjStartNfa_0(11, n);
        }
        try {
            this.curChar = this.input_stream.readChar();
        }
        catch (IOException ex) {
            this.jjStopStringLiteralDfa_0(12, n2);
            return 13;
        }
        switch (this.curChar) {
            case 'i': {
                return this.jjMoveStringLiteralDfa14_0(n2, 4194304L);
            }
            case 'y': {
                if ((n2 & 0x200000L) != 0x0L) {
                    return this.jjStartNfaWithStates_0(13, 21, 51);
                }
                break;
            }
        }
        return this.jjStartNfa_0(12, n2);
    }
    
    private final int jjMoveStringLiteralDfa14_0(long n, long n2) {
        if ((n2 &= n) == 0x0L) {
            return this.jjStartNfa_0(12, n);
        }
        try {
            this.curChar = this.input_stream.readChar();
        }
        catch (IOException ex) {
            this.jjStopStringLiteralDfa_0(13, n2);
            return 14;
        }
        switch (this.curChar) {
            case 't': {
                return this.jjMoveStringLiteralDfa15_0(n2, 4194304L);
            }
            default: {
                return this.jjStartNfa_0(13, n2);
            }
        }
    }
    
    private final int jjMoveStringLiteralDfa15_0(long n, long n2) {
        if ((n2 &= n) == 0x0L) {
            return this.jjStartNfa_0(13, n);
        }
        try {
            this.curChar = this.input_stream.readChar();
        }
        catch (IOException ex) {
            this.jjStopStringLiteralDfa_0(14, n2);
            return 15;
        }
        switch (this.curChar) {
            case 'y': {
                if ((n2 & 0x400000L) != 0x0L) {
                    return this.jjStartNfaWithStates_0(15, 22, 51);
                }
                break;
            }
        }
        return this.jjStartNfa_0(14, n2);
    }
    
    private final void jjCheckNAdd(int n) {
        if (this.jjrounds[n] != this.jjround) {
            this.jjstateSet[this.jjnewStateCnt++] = n;
            this.jjrounds[n] = this.jjround;
        }
    }
    
    private final void jjAddStates(int n, int n2) {
        do {
            this.jjstateSet[this.jjnewStateCnt++] = ParserTokenManager.jjnextStates[n];
        } while (n++ != n2);
    }
    
    private final void jjCheckNAddTwoStates(int n, int n2) {
        this.jjCheckNAdd(n);
        this.jjCheckNAdd(n2);
    }
    
    private final void jjCheckNAddStates(int n, int n2) {
        do {
            this.jjCheckNAdd(ParserTokenManager.jjnextStates[n]);
        } while (n++ != n2);
    }
    
    private final void jjCheckNAddStates(int n) {
        this.jjCheckNAdd(ParserTokenManager.jjnextStates[n]);
        this.jjCheckNAdd(ParserTokenManager.jjnextStates[n + 1]);
    }
    
    private final int jjMoveNfa_0(int n, int jjmatchedPos) {
        int n2 = 0;
        this.jjnewStateCnt = 47;
        int i = 1;
        this.jjstateSet[0] = n;
        int jjmatchedKind = Integer.MAX_VALUE;
        while (true) {
            if (++this.jjround == Integer.MAX_VALUE) {
                this.ReInitRounds();
            }
            if (this.curChar < '@') {
                long n6 = 1L << this.curChar;
                do {
                    switch (this.jjstateSet[--i]) {
                        case 49: {
                            if ((0x3FF200000000000L & n6) != 0x0L) {
                                this.jjCheckNAddTwoStates(18, 19);
                            }
                            if ((0x3FF000000000000L & n6) != 0x0L) {
                                if (jjmatchedKind > 31) {
                                    jjmatchedKind = 31;
                                }
                                this.jjCheckNAddStates(0, 2);
                            }
                            if ((0x3FF000000000000L & n6) != 0x0L) {
                                if (jjmatchedKind > 31) {
                                    jjmatchedKind = 31;
                                }
                                this.jjCheckNAdd(20);
                            }
                            if ((0x3FF000000000000L & n6) != 0x0L) {
                                if (jjmatchedKind > 31) {
                                    jjmatchedKind = 31;
                                }
                                this.jjCheckNAdd(19);
                                continue;
                            }
                            else {
                                continue;
                            }
                        }
                        case 48: {
                            if ((0x3FF200000000000L & n6) != 0x0L) {
                                this.jjCheckNAddTwoStates(18, 19);
                            }
                            else if (this.curChar == ':') {
                                this.jjCheckNAddStates(3, 5);
                            }
                            if ((0x3FF000000000000L & n6) != 0x0L) {
                                if (jjmatchedKind > 31) {
                                    jjmatchedKind = 31;
                                }
                                this.jjCheckNAddStates(0, 2);
                            }
                            else if (this.curChar == ':') {
                                this.jjCheckNAddTwoStates(23, 25);
                            }
                            if ((0x3FF000000000000L & n6) != 0x0L) {
                                if (jjmatchedKind > 31) {
                                    jjmatchedKind = 31;
                                }
                                this.jjCheckNAdd(20);
                            }
                            if ((0x3FF000000000000L & n6) != 0x0L) {
                                this.jjCheckNAddTwoStates(26, 27);
                            }
                            if ((0x3FF000000000000L & n6) != 0x0L) {
                                this.jjCheckNAddTwoStates(23, 24);
                                continue;
                            }
                            continue;
                        }
                        case 47: {
                            if ((0x3FF200000000000L & n6) != 0x0L) {
                                this.jjCheckNAddTwoStates(18, 19);
                            }
                            if ((0x3FF000000000000L & n6) != 0x0L) {
                                if (jjmatchedKind > 31) {
                                    jjmatchedKind = 31;
                                }
                                this.jjCheckNAddStates(0, 2);
                            }
                            if ((0x3FF000000000000L & n6) != 0x0L) {
                                if (jjmatchedKind > 31) {
                                    jjmatchedKind = 31;
                                }
                                this.jjCheckNAdd(20);
                                continue;
                            }
                            else {
                                continue;
                            }
                        }
                        case 50: {
                            if ((0x3FF200000000000L & n6) != 0x0L) {
                                this.jjCheckNAddTwoStates(18, 19);
                            }
                            else if (this.curChar == ':') {
                                this.jjCheckNAddStates(3, 5);
                            }
                            if ((0x3FF000000000000L & n6) != 0x0L) {
                                if (jjmatchedKind > 31) {
                                    jjmatchedKind = 31;
                                }
                                this.jjCheckNAddStates(0, 2);
                            }
                            else if (this.curChar == ':') {
                                this.jjCheckNAddTwoStates(23, 25);
                            }
                            if ((0x3FF000000000000L & n6) != 0x0L) {
                                if (jjmatchedKind > 31) {
                                    jjmatchedKind = 31;
                                }
                                this.jjCheckNAdd(20);
                            }
                            if ((0x3FF000000000000L & n6) != 0x0L) {
                                if (jjmatchedKind > 31) {
                                    jjmatchedKind = 31;
                                }
                                this.jjCheckNAdd(19);
                            }
                            if ((0x3FF000000000000L & n6) != 0x0L) {
                                this.jjCheckNAddTwoStates(26, 27);
                            }
                            if ((0x3FF000000000000L & n6) != 0x0L) {
                                this.jjCheckNAddTwoStates(23, 24);
                                continue;
                            }
                            continue;
                        }
                        case 5: {
                            if ((0x3FF000000000000L & n6) != 0x0L) {
                                this.jjCheckNAddStates(6, 9);
                            }
                            else if (this.curChar == ':') {
                                this.jjAddStates(10, 11);
                            }
                            else if (this.curChar == '\"') {
                                this.jjCheckNAddTwoStates(15, 16);
                            }
                            else if (this.curChar == '#') {
                                this.jjCheckNAddStates(12, 14);
                            }
                            else if (this.curChar == '-') {
                                this.jjstateSet[this.jjnewStateCnt++] = 0;
                            }
                            if ((0x3FF000000000000L & n6) != 0x0L) {
                                if (jjmatchedKind > 31) {
                                    jjmatchedKind = 31;
                                }
                                this.jjCheckNAddStates(15, 17);
                            }
                            if ((0x3FE000000000000L & n6) != 0x0L) {
                                if (jjmatchedKind > 24) {
                                    jjmatchedKind = 24;
                                }
                                this.jjCheckNAddTwoStates(12, 13);
                                continue;
                            }
                            else if (this.curChar == '0') {
                                if (jjmatchedKind > 24) {
                                    jjmatchedKind = 24;
                                }
                                this.jjCheckNAddStates(18, 20);
                                continue;
                            }
                            else {
                                continue;
                            }
                        }
                        case 51: {
                            if ((0x3FF200000000000L & n6) != 0x0L) {
                                this.jjCheckNAddTwoStates(18, 19);
                            }
                            if ((0x3FF000000000000L & n6) != 0x0L) {
                                if (jjmatchedKind > 31) {
                                    jjmatchedKind = 31;
                                }
                                this.jjCheckNAdd(19);
                                continue;
                            }
                            else {
                                continue;
                            }
                        }
                        case 0: {
                            if (this.curChar == '-') {
                                this.jjCheckNAddStates(21, 23);
                                continue;
                            }
                            continue;
                        }
                        case 1: {
                            if ((0xFFFFFFFFFFFFDBFFL & n6) != 0x0L) {
                                this.jjCheckNAddStates(21, 23);
                                continue;
                            }
                            continue;
                        }
                        case 2: {
                            if ((0x2400L & n6) != 0x0L && jjmatchedKind > 5) {
                                jjmatchedKind = 5;
                                continue;
                            }
                            continue;
                        }
                        case 3: {
                            if (this.curChar == '\n' && jjmatchedKind > 5) {
                                jjmatchedKind = 5;
                                continue;
                            }
                            continue;
                        }
                        case 4: {
                            if (this.curChar == '\r') {
                                this.jjstateSet[this.jjnewStateCnt++] = 3;
                                continue;
                            }
                            continue;
                        }
                        case 6: {
                            if (this.curChar == '#') {
                                this.jjCheckNAddStates(12, 14);
                                continue;
                            }
                            continue;
                        }
                        case 7: {
                            if ((0xFFFFFFFFFFFFDBFFL & n6) != 0x0L) {
                                this.jjCheckNAddStates(12, 14);
                                continue;
                            }
                            continue;
                        }
                        case 8: {
                            if ((0x2400L & n6) != 0x0L && jjmatchedKind > 6) {
                                jjmatchedKind = 6;
                                continue;
                            }
                            continue;
                        }
                        case 9: {
                            if (this.curChar == '\n' && jjmatchedKind > 6) {
                                jjmatchedKind = 6;
                                continue;
                            }
                            continue;
                        }
                        case 10: {
                            if (this.curChar == '\r') {
                                this.jjstateSet[this.jjnewStateCnt++] = 9;
                                continue;
                            }
                            continue;
                        }
                        case 11: {
                            if ((0x3FE000000000000L & n6) == 0x0L) {
                                continue;
                            }
                            if (jjmatchedKind > 24) {
                                jjmatchedKind = 24;
                            }
                            this.jjCheckNAddTwoStates(12, 13);
                            continue;
                        }
                        case 12: {
                            if ((0x3FF000000000000L & n6) == 0x0L) {
                                continue;
                            }
                            if (jjmatchedKind > 24) {
                                jjmatchedKind = 24;
                            }
                            this.jjCheckNAddTwoStates(12, 13);
                            continue;
                        }
                        case 14: {
                            if (this.curChar == '\"') {
                                this.jjCheckNAddTwoStates(15, 16);
                                continue;
                            }
                            continue;
                        }
                        case 15: {
                            if ((0xFFFFFFFBFFFFFFFFL & n6) != 0x0L) {
                                this.jjCheckNAddTwoStates(15, 16);
                                continue;
                            }
                            continue;
                        }
                        case 16: {
                            if (this.curChar == '\"' && jjmatchedKind > 35) {
                                jjmatchedKind = 35;
                                continue;
                            }
                            continue;
                        }
                        case 17: {
                            if ((0x3FF000000000000L & n6) == 0x0L) {
                                continue;
                            }
                            if (jjmatchedKind > 31) {
                                jjmatchedKind = 31;
                            }
                            this.jjCheckNAddStates(15, 17);
                            continue;
                        }
                        case 18: {
                            if ((0x3FF200000000000L & n6) != 0x0L) {
                                this.jjCheckNAddTwoStates(18, 19);
                                continue;
                            }
                            continue;
                        }
                        case 19: {
                            if ((0x3FF000000000000L & n6) == 0x0L) {
                                continue;
                            }
                            if (jjmatchedKind > 31) {
                                jjmatchedKind = 31;
                            }
                            this.jjCheckNAdd(19);
                            continue;
                        }
                        case 20: {
                            if ((0x3FF000000000000L & n6) == 0x0L) {
                                continue;
                            }
                            if (jjmatchedKind > 31) {
                                jjmatchedKind = 31;
                            }
                            this.jjCheckNAdd(20);
                            continue;
                        }
                        case 21: {
                            if ((0x3FF000000000000L & n6) == 0x0L) {
                                continue;
                            }
                            if (jjmatchedKind > 31) {
                                jjmatchedKind = 31;
                            }
                            this.jjCheckNAddStates(0, 2);
                            continue;
                        }
                        case 22: {
                            if ((0x3FF000000000000L & n6) != 0x0L) {
                                this.jjCheckNAddStates(6, 9);
                                continue;
                            }
                            continue;
                        }
                        case 23: {
                            if ((0x3FF000000000000L & n6) != 0x0L) {
                                this.jjCheckNAddTwoStates(23, 24);
                                continue;
                            }
                            continue;
                        }
                        case 24: {
                            if (this.curChar == ':') {
                                this.jjCheckNAddTwoStates(23, 25);
                                continue;
                            }
                            continue;
                        }
                        case 25:
                        case 41: {
                            if (this.curChar == ':' && jjmatchedKind > 28) {
                                jjmatchedKind = 28;
                                continue;
                            }
                            continue;
                        }
                        case 26: {
                            if ((0x3FF000000000000L & n6) != 0x0L) {
                                this.jjCheckNAddTwoStates(26, 27);
                                continue;
                            }
                            continue;
                        }
                        case 27: {
                            if (this.curChar == ':') {
                                this.jjCheckNAddStates(3, 5);
                                continue;
                            }
                            continue;
                        }
                        case 28:
                        case 42: {
                            if (this.curChar == ':') {
                                this.jjCheckNAddTwoStates(29, 36);
                                continue;
                            }
                            continue;
                        }
                        case 29: {
                            if ((0x3FF000000000000L & n6) != 0x0L) {
                                this.jjCheckNAddTwoStates(29, 30);
                                continue;
                            }
                            continue;
                        }
                        case 30: {
                            if (this.curChar == '.') {
                                this.jjCheckNAdd(31);
                                continue;
                            }
                            continue;
                        }
                        case 31: {
                            if ((0x3FF000000000000L & n6) != 0x0L) {
                                this.jjCheckNAddTwoStates(31, 32);
                                continue;
                            }
                            continue;
                        }
                        case 32: {
                            if (this.curChar == '.') {
                                this.jjCheckNAdd(33);
                                continue;
                            }
                            continue;
                        }
                        case 33: {
                            if ((0x3FF000000000000L & n6) != 0x0L) {
                                this.jjCheckNAddTwoStates(33, 34);
                                continue;
                            }
                            continue;
                        }
                        case 34: {
                            if (this.curChar == '.') {
                                this.jjCheckNAdd(35);
                                continue;
                            }
                            continue;
                        }
                        case 35: {
                            if ((0x3FF000000000000L & n6) == 0x0L) {
                                continue;
                            }
                            if (jjmatchedKind > 28) {
                                jjmatchedKind = 28;
                            }
                            this.jjCheckNAdd(35);
                            continue;
                        }
                        case 36: {
                            if ((0x3FF000000000000L & n6) == 0x0L) {
                                continue;
                            }
                            if (jjmatchedKind > 28) {
                                jjmatchedKind = 28;
                            }
                            this.jjCheckNAddStates(24, 26);
                            continue;
                        }
                        case 37: {
                            if ((0x3FF000000000000L & n6) != 0x0L) {
                                this.jjCheckNAddTwoStates(37, 28);
                                continue;
                            }
                            continue;
                        }
                        case 38: {
                            if ((0x3FF000000000000L & n6) == 0x0L) {
                                continue;
                            }
                            if (jjmatchedKind > 28) {
                                jjmatchedKind = 28;
                            }
                            this.jjCheckNAdd(38);
                            continue;
                        }
                        case 39: {
                            if ((0x3FF000000000000L & n6) == 0x0L) {
                                continue;
                            }
                            if (jjmatchedKind > 28) {
                                jjmatchedKind = 28;
                            }
                            this.jjCheckNAddStates(27, 31);
                            continue;
                        }
                        case 40: {
                            if (this.curChar == ':') {
                                this.jjAddStates(10, 11);
                                continue;
                            }
                            continue;
                        }
                        case 43: {
                            if (this.curChar != '0') {
                                continue;
                            }
                            if (jjmatchedKind > 24) {
                                jjmatchedKind = 24;
                            }
                            this.jjCheckNAddStates(18, 20);
                            continue;
                        }
                        case 45: {
                            if ((0x3FF000000000000L & n6) == 0x0L) {
                                continue;
                            }
                            if (jjmatchedKind > 24) {
                                jjmatchedKind = 24;
                            }
                            this.jjCheckNAddTwoStates(45, 13);
                            continue;
                        }
                        case 46: {
                            if ((0xFF000000000000L & n6) == 0x0L) {
                                continue;
                            }
                            if (jjmatchedKind > 24) {
                                jjmatchedKind = 24;
                            }
                            this.jjCheckNAddTwoStates(46, 13);
                        }
                        default: {
                            continue;
                        }
                    }
                } while (i != n2);
            }
            else if (this.curChar < '\u0080') {
                long n5 = 1L << (this.curChar & '?');
                do {
                    switch (this.jjstateSet[--i]) {
                        case 49: {
                            if ((0x7FFFFFE87FFFFFEL & n5) != 0x0L) {
                                this.jjCheckNAddTwoStates(18, 19);
                            }
                            if ((0x7FFFFFE07FFFFFEL & n5) != 0x0L) {
                                if (jjmatchedKind > 31) {
                                    jjmatchedKind = 31;
                                }
                                this.jjCheckNAddStates(0, 2);
                            }
                            if ((0x7FFFFFE07FFFFFEL & n5) != 0x0L) {
                                if (jjmatchedKind > 31) {
                                    jjmatchedKind = 31;
                                }
                                this.jjCheckNAdd(20);
                            }
                            if ((0x7FFFFFE07FFFFFEL & n5) != 0x0L) {
                                if (jjmatchedKind > 31) {
                                    jjmatchedKind = 31;
                                }
                                this.jjCheckNAdd(19);
                                continue;
                            }
                            else {
                                continue;
                            }
                        }
                        case 48: {
                            if ((0x7FFFFFE87FFFFFEL & n5) != 0x0L) {
                                this.jjCheckNAddTwoStates(18, 19);
                            }
                            if ((0x7FFFFFE07FFFFFEL & n5) != 0x0L) {
                                if (jjmatchedKind > 31) {
                                    jjmatchedKind = 31;
                                }
                                this.jjCheckNAddStates(0, 2);
                            }
                            if ((0x7FFFFFE07FFFFFEL & n5) != 0x0L) {
                                if (jjmatchedKind > 31) {
                                    jjmatchedKind = 31;
                                }
                                this.jjCheckNAdd(20);
                            }
                            if ((0x7E0000007EL & n5) != 0x0L) {
                                this.jjCheckNAddTwoStates(26, 27);
                            }
                            if ((0x7E0000007EL & n5) != 0x0L) {
                                this.jjCheckNAddTwoStates(23, 24);
                                continue;
                            }
                            continue;
                        }
                        case 47: {
                            if ((0x7FFFFFE87FFFFFEL & n5) != 0x0L) {
                                this.jjCheckNAddTwoStates(18, 19);
                            }
                            if ((0x7FFFFFE07FFFFFEL & n5) != 0x0L) {
                                if (jjmatchedKind > 31) {
                                    jjmatchedKind = 31;
                                }
                                this.jjCheckNAddStates(0, 2);
                            }
                            if ((0x7FFFFFE07FFFFFEL & n5) != 0x0L) {
                                if (jjmatchedKind > 31) {
                                    jjmatchedKind = 31;
                                }
                                this.jjCheckNAdd(20);
                                continue;
                            }
                            else {
                                continue;
                            }
                        }
                        case 50: {
                            if ((0x7FFFFFE87FFFFFEL & n5) != 0x0L) {
                                this.jjCheckNAddTwoStates(18, 19);
                            }
                            if ((0x7FFFFFE07FFFFFEL & n5) != 0x0L) {
                                if (jjmatchedKind > 31) {
                                    jjmatchedKind = 31;
                                }
                                this.jjCheckNAddStates(0, 2);
                            }
                            if ((0x7FFFFFE07FFFFFEL & n5) != 0x0L) {
                                if (jjmatchedKind > 31) {
                                    jjmatchedKind = 31;
                                }
                                this.jjCheckNAdd(20);
                            }
                            if ((0x7FFFFFE07FFFFFEL & n5) != 0x0L) {
                                if (jjmatchedKind > 31) {
                                    jjmatchedKind = 31;
                                }
                                this.jjCheckNAdd(19);
                            }
                            if ((0x7E0000007EL & n5) != 0x0L) {
                                this.jjCheckNAddTwoStates(26, 27);
                            }
                            if ((0x7E0000007EL & n5) != 0x0L) {
                                this.jjCheckNAddTwoStates(23, 24);
                                continue;
                            }
                            continue;
                        }
                        case 5: {
                            if ((0x7FFFFFE07FFFFFEL & n5) != 0x0L) {
                                if (jjmatchedKind > 31) {
                                    jjmatchedKind = 31;
                                }
                                this.jjCheckNAddStates(15, 17);
                            }
                            if ((0x7E0000007EL & n5) != 0x0L) {
                                this.jjCheckNAddStates(6, 9);
                                continue;
                            }
                            continue;
                        }
                        case 51: {
                            if ((0x7FFFFFE87FFFFFEL & n5) != 0x0L) {
                                this.jjCheckNAddTwoStates(18, 19);
                            }
                            if ((0x7FFFFFE07FFFFFEL & n5) != 0x0L) {
                                if (jjmatchedKind > 31) {
                                    jjmatchedKind = 31;
                                }
                                this.jjCheckNAdd(19);
                                continue;
                            }
                            else {
                                continue;
                            }
                        }
                        case 1: {
                            this.jjAddStates(21, 23);
                            continue;
                        }
                        case 7: {
                            this.jjAddStates(12, 14);
                            continue;
                        }
                        case 13: {
                            if ((0x100000001000L & n5) != 0x0L && jjmatchedKind > 24) {
                                jjmatchedKind = 24;
                                continue;
                            }
                            continue;
                        }
                        case 15: {
                            this.jjAddStates(32, 33);
                            continue;
                        }
                        case 17: {
                            if ((0x7FFFFFE07FFFFFEL & n5) == 0x0L) {
                                continue;
                            }
                            if (jjmatchedKind > 31) {
                                jjmatchedKind = 31;
                            }
                            this.jjCheckNAddStates(15, 17);
                            continue;
                        }
                        case 18: {
                            if ((0x7FFFFFE87FFFFFEL & n5) != 0x0L) {
                                this.jjCheckNAddTwoStates(18, 19);
                                continue;
                            }
                            continue;
                        }
                        case 19: {
                            if ((0x7FFFFFE07FFFFFEL & n5) == 0x0L) {
                                continue;
                            }
                            if (jjmatchedKind > 31) {
                                jjmatchedKind = 31;
                            }
                            this.jjCheckNAdd(19);
                            continue;
                        }
                        case 20: {
                            if ((0x7FFFFFE07FFFFFEL & n5) == 0x0L) {
                                continue;
                            }
                            if (jjmatchedKind > 31) {
                                jjmatchedKind = 31;
                            }
                            this.jjCheckNAdd(20);
                            continue;
                        }
                        case 21: {
                            if ((0x7FFFFFE07FFFFFEL & n5) == 0x0L) {
                                continue;
                            }
                            if (jjmatchedKind > 31) {
                                jjmatchedKind = 31;
                            }
                            this.jjCheckNAddStates(0, 2);
                            continue;
                        }
                        case 22: {
                            if ((0x7E0000007EL & n5) != 0x0L) {
                                this.jjCheckNAddStates(6, 9);
                                continue;
                            }
                            continue;
                        }
                        case 23: {
                            if ((0x7E0000007EL & n5) != 0x0L) {
                                this.jjCheckNAddTwoStates(23, 24);
                                continue;
                            }
                            continue;
                        }
                        case 26: {
                            if ((0x7E0000007EL & n5) != 0x0L) {
                                this.jjCheckNAddTwoStates(26, 27);
                                continue;
                            }
                            continue;
                        }
                        case 36: {
                            if ((0x7E0000007EL & n5) == 0x0L) {
                                continue;
                            }
                            if (jjmatchedKind > 28) {
                                jjmatchedKind = 28;
                            }
                            this.jjCheckNAddStates(24, 26);
                            continue;
                        }
                        case 37: {
                            if ((0x7E0000007EL & n5) != 0x0L) {
                                this.jjCheckNAddTwoStates(37, 28);
                                continue;
                            }
                            continue;
                        }
                        case 38: {
                            if ((0x7E0000007EL & n5) == 0x0L) {
                                continue;
                            }
                            if (jjmatchedKind > 28) {
                                jjmatchedKind = 28;
                            }
                            this.jjCheckNAdd(38);
                            continue;
                        }
                        case 39: {
                            if ((0x7E0000007EL & n5) == 0x0L) {
                                continue;
                            }
                            if (jjmatchedKind > 28) {
                                jjmatchedKind = 28;
                            }
                            this.jjCheckNAddStates(27, 31);
                            continue;
                        }
                        case 44: {
                            if ((0x100000001000000L & n5) != 0x0L) {
                                this.jjCheckNAdd(45);
                                continue;
                            }
                            continue;
                        }
                        case 45: {
                            if ((0x7E0000007EL & n5) == 0x0L) {
                                continue;
                            }
                            if (jjmatchedKind > 24) {
                                jjmatchedKind = 24;
                            }
                            this.jjCheckNAddTwoStates(45, 13);
                        }
                        default: {
                            continue;
                        }
                    }
                } while (i != n2);
            }
            else {
                int n3 = (this.curChar & 'ÿ') >> 6;
                long n4 = 1L << (this.curChar & '?');
                do {
                    switch (this.jjstateSet[--i]) {
                        case 1: {
                            if ((ParserTokenManager.jjbitVec0[n3] & n4) != 0x0L) {
                                this.jjAddStates(21, 23);
                                continue;
                            }
                            continue;
                        }
                        case 7: {
                            if ((ParserTokenManager.jjbitVec0[n3] & n4) != 0x0L) {
                                this.jjAddStates(12, 14);
                                continue;
                            }
                            continue;
                        }
                        case 15: {
                            if ((ParserTokenManager.jjbitVec0[n3] & n4) != 0x0L) {
                                this.jjAddStates(32, 33);
                            }
                            else {
                                continue;
                            }
                        }
                        default: {
                            continue;
                        }
                    }
                } while (i != n2);
            }
            if (jjmatchedKind != Integer.MAX_VALUE) {
                this.jjmatchedKind = jjmatchedKind;
                this.jjmatchedPos = jjmatchedPos;
                jjmatchedKind = Integer.MAX_VALUE;
            }
            ++jjmatchedPos;
            int n7 = i = this.jjnewStateCnt;
            int n8 = 47;
            int jjnewStateCnt = n2;
            this.jjnewStateCnt = jjnewStateCnt;
            if (n7 == (n2 = n8 - jjnewStateCnt)) {
                break;
            }
            try {
                this.curChar = this.input_stream.readChar();
            }
            catch (IOException ex) {
                return jjmatchedPos;
            }
        }
        return jjmatchedPos;
    }
    
    public ParserTokenManager(ASCII_CharStream input_stream) {
        this.jjrounds = new int[47];
        this.jjstateSet = new int[94];
        this.curLexState = 0;
        this.defaultLexState = 0;
        this.input_stream = input_stream;
    }
    
    public ParserTokenManager(ASCII_CharStream ascii_CharStream, int n) {
        this(ascii_CharStream);
        this.SwitchTo(n);
    }
    
    public void ReInit(ASCII_CharStream input_stream) {
        int n = 0;
        this.jjnewStateCnt = n;
        this.jjmatchedPos = n;
        this.curLexState = this.defaultLexState;
        this.input_stream = input_stream;
        this.ReInitRounds();
    }
    
    private final void ReInitRounds() {
        this.jjround = -2147483647;
        int n = 47;
        while (n-- > 0) {
            this.jjrounds[n] = Integer.MIN_VALUE;
        }
    }
    
    public void ReInit(ASCII_CharStream ascii_CharStream, int n) {
        this.ReInit(ascii_CharStream);
        this.SwitchTo(n);
    }
    
    public void SwitchTo(int n) {
        if (n >= 1 || n < 0) {
            throw new TokenMgrError("Error: Ignoring invalid lexical state : " + n + ". State unchanged.", 2);
        }
        this.curLexState = n;
        return;
    }
    
    private final Token jjFillToken() {
        Token token = Token.newToken(this.jjmatchedKind);
        token.kind = this.jjmatchedKind;
        String s = ParserTokenManager.jjstrLiteralImages[this.jjmatchedKind];
        token.image = ((s == null) ? this.input_stream.GetImage() : s);
        token.beginLine = this.input_stream.getBeginLine();
        token.beginColumn = this.input_stream.getBeginColumn();
        token.endLine = this.input_stream.getEndLine();
        token.endColumn = this.input_stream.getEndColumn();
        return token;
    }
    
    public final Token getNextToken() {
        while (true) {
            try {
                this.curChar = this.input_stream.BeginToken();
            }
            catch (IOException ex) {
                this.jjmatchedKind = 0;
                return this.jjFillToken();
            }
            try {
                this.input_stream.backup(0);
                while (this.curChar <= ' ' && (0x100002600L & 1L << this.curChar) != 0x0L) {
                    this.curChar = this.input_stream.BeginToken();
                }
            }
            catch (IOException ex2) {
                continue;
            }
            this.jjmatchedKind = Integer.MAX_VALUE;
            this.jjmatchedPos = 0;
            int jjMoveStringLiteralDfa0_0 = this.jjMoveStringLiteralDfa0_0();
            if (this.jjmatchedKind != Integer.MAX_VALUE) {
                if (this.jjmatchedPos + 1 < jjMoveStringLiteralDfa0_0) {
                    this.input_stream.backup(jjMoveStringLiteralDfa0_0 - this.jjmatchedPos - 1);
                }
                if ((ParserTokenManager.jjtoToken[this.jjmatchedKind >> 6] & 1L << (this.jjmatchedKind & 0x3F)) == 0x0L) {
                    continue;
                }
                return this.jjFillToken();
            }
            else {
                int endLine = this.input_stream.getEndLine();
                int endColumn = this.input_stream.getEndColumn();
                String s = null;
                boolean n = false;
                try {
                    this.input_stream.readChar();
                    this.input_stream.backup(1);
                }
                catch (IOException ex3) {
                    n = true;
                    s = ((jjMoveStringLiteralDfa0_0 <= 1) ? "" : this.input_stream.GetImage());
                    if (this.curChar == '\n' || this.curChar == '\r') {
                        ++endLine;
                        endColumn = 0;
                    }
                    else {
                        ++endColumn;
                    }
                }
                if (n == 0) {
                    this.input_stream.backup(1);
                    s = ((jjMoveStringLiteralDfa0_0 <= 1) ? "" : this.input_stream.GetImage());
                }
                throw new TokenMgrError((boolean)n, this.curLexState, endLine, endColumn, s, this.curChar, 0);
            }
        }
    }
    
    static {
        jjbitVec0 = new long[] { 0L, 0L, -1L, -1L };
        jjnextStates = new int[] { 18, 19, 21, 28, 29, 39, 23, 24, 26, 27, 41, 42, 7, 8, 10, 18, 20, 21, 44, 46, 13, 1, 2, 4, 37, 28, 38, 26, 27, 37, 28, 38, 15, 16 };
        jjstrLiteralImages = new String[] { "", null, null, null, null, null, null, "access", "acl", "=", "communities", "enterprise", "hosts", "{", "managers", "-", "}", "read-only", "read-write", "trap", "inform", "trap-community", "inform-community", "trap-num", null, null, null, null, null, null, null, null, null, null, null, null, ",", ".", "!", "/" };
        lexStateNames = new String[] { "DEFAULT" };
        jjtoToken = new long[] { 1067601362817L };
        jjtoSkip = new long[] { 126L };
    }
}
